#!/bin/bash
#Endzeitausgabe Prusa MK3-Klipper in variables.cfg z.B. endtime = 'EZ=2021-03-28_21:22'       kgolger_12.04.2022
home="/home/pi"
variables=$home"/variables.cfg" #Klipperfile saved variables
druckzeit="" #Druckzeit eingetragen?
#
#Init Klipper
#$home/sendgcode.sh
#
# suche aktuellstes gcode Upload
upload=$home"/gcode_files/"
file=$(ls -rt $upload | tail -1)
if [ -z $file ]; then
        echo ""
        echo "Gcode Verzeichnis leer!"
        echo ""
        sed -i 's/filename =.*/filename ='" \'\'"'/' "$variables"
        exit
fi
if [ ! -f $variables ]; then
        echo ""
        echo "variables.cfg nicht vorhanden!"
        echo ""
        exit
fi
#
#Server- und Druckzeit auslesen, Endzeit berechnen, Endzeit in variables.cfg und Druck starten
#
#Serverzeit
serverzeit=`date +%A-%d-%m-%y-%H:%M:%S`
#Druckzeit
druckzeit=$(grep -rw "M73" $upload$file | wc -l)
if [ $druckzeit -ge 1 ]; then
        druckzeit=$(grep --max-count=1 "M73 P0 S" $upload$file | cut -d "S" -f 2)
        if [ -z $druckzeit ];then
                druckzeit=$(grep --max-count=1 "M73 P0 R" $upload$file | cut -d "R" -f 2)
        fi
        #Endzeit berechnen
        druckzeit=`echo "$druckzeit+10"|bc` # ungefähre Aufwärmzeit addieren
	endzeit="'EZ->`date -d "+ $druckzeit minutes" +%Y-%m-%d_%H:%M | cut -b 1-20`'"
        #Endzeit in variables.cfg eintragen
	sed -i 's/endtime =.*/endtime ='" $endzeit"'/' "$variables"
        #Gcode Dateiname in variables.cfg eintragen
        sed -i 's/filename =.*/filename ='" \'$file\'"'/' "$variables"
else
        sed -i 's/endtime =.*/endtime ='" \'EZ-> unbekannt\'"'/' "$variables"
        echo ""
        echo "Keine Druckzeit im gcode gefunden!"
        echo "Druck wird ohne Endzeit Ausgabe gestartet!"
        echo ""
fi
exit
